package jirc;

import java.io.Serializable;
import java.util.List;

public class Channel implements Serializable {
    public String Name = null;
    private Person[] People = null;
    private List<Person> People2 = null;
    public boolean IRP = false;

    public Channel(String name, Person people[]) {
	Name = name;
	People = people;
    }

    public void addMember(Person member) {
	if (inArray(People, member) == -1) {
	    People = (Person[])resizeArray(People, People.length + 1);
	    People[People.length - 1] = member;
	} else {
	    People[inArray(People, member)].makeActive();
	}
    }

    public void addMember(String member) {
	if (inPersonArray(People, member) == -1) {
	    People = (Person[])resizeArray(People, People.length + 1);
	    People[People.length - 1] = new Person(member);
	} else {
	    People[inPersonArray(People, member)].makeActive();
	}
    }

    public void removeMember(Person member) {
	People[inArray(People, member)].makeInactive();
    }

    public void removeMember(String member) {
	People[inPersonArray(People, member)].makeInactive();
    }

    public void makeActive(Person member) {
	People[inArray(People, member)].makeActive();
    }

    public void makeActive(String member) {
	People[inPersonArray(People, member)].makeActive();
    }

    public int isMember(Person member) {
	return inArray(People, member);
    }

    public int isMember(String member) {
	return inPersonArray(People, member);
    }

    public boolean isChanOp(Person member) {
	int tmp = inArray(People, member);
	if (tmp > -1) return People[tmp].isOperator();
	return false;
    }

    public boolean isChanOp(String member) {
	int tmp = inPersonArray(People, member);
	if (tmp > -1) return People[tmp].isOperator();
	return false;
    }

    public Person[] getActiveMembers() {
	Person[] people = new Person[0];
	for (int x = 0; x < People.length; x++) {
	    if (People[x].isActive()) {
		people = (Person[])resizeArray(people, people.length + 1);
		people[people.length - 1] = People[x];
	    }
	}
	return people;
    }

    public Person[] getAllMembers() {
	return People;
    }

    private static Object resizeArray(Object oldArray, int newSize) {
	int oldSize = java.lang.reflect.Array.getLength(oldArray);
	Class elementType = oldArray.getClass().getComponentType();
	Object newArray = java.lang.reflect.Array.newInstance(elementType, newSize);
	int preserveLength = Math.min(oldSize,newSize);
	if (preserveLength > 0) System.arraycopy(oldArray, 0, newArray, 0, preserveLength);
	return newArray;
    }

    public static int inArray(Object[] arr, Object match) {
        for (int x = 0; x < arr.length; x++) {
            if (arr[x] != null) {if (arr[x].equals(match)) return x;}
        }
        return -1;
    }

    public static int inPersonArray(Person[] arr, String match) {
        for (int x = 0; x < arr.length; x++) {
            if (arr[x] != null) {if (arr[x].getName().equalsIgnoreCase(match)) return x;}
        }
        return -1;
    }
}
