package jirc;

import java.io.Serializable;

public class Person implements Serializable {
    private String Name = "";
    private boolean Operator = false;
    private boolean Voiced = false;
    private String Modes = "";
    private boolean Active = true;

    public Person(String all) {
	Operator = all.contains("@");
	Voiced = all.contains("+") || Operator;
	Modes = ((Operator) ? "@" : "") + ((Voiced) ? "+" : "");
	Name = all.replaceAll("@|\\+", "");
    }

    public Person(String name, boolean op, boolean voiced) {
	Name = name;
	Operator = op;
	Voiced = voiced;
	Modes = ((Operator) ? "@" : "") + ((Voiced) ? "+" : "");
    }

    public Person(String name, String modes) {
	Name = name;
	Modes = modes;
	Operator = Modes.contains("@");
	Voiced = Modes.contains("+") || Operator;
    }

    public String getName() {
	return Name;
    }

    public String getModes() {
	return Modes;
    }

    public void setModes(String modes) {
	Modes = modes;
	Operator = Modes.contains("@");
	Voiced = Modes.contains("+") || Operator;
    }

    public boolean isOperator() {
	return Operator;
    }

    public boolean isVoiced() {
	return Voiced;
    }
    
    public boolean isActive() {
	return Active;
    }

    public void makeOperator() {
	Operator = true;
	Modes += "@";
    }

    public void makeVoiced() {
	Voiced = true;
	Modes += "+";
    }

    public void makeActive() {
	Active = true;
    }

    public void makeInactive() {
	Active = false;
    }

    public void removeOperator() {
	Operator = false;
	Modes.replace("@", "");
    }

    public void removeVoiced() {
	Voiced = false;
	Modes.replace("+", "");
    }
}
